;=======================================;
;Title: DBZ: Assault of the Saiyans 	;
;Huffman-Compatible Variable Read	;
;=======================================;
;Rewrite of the variable code so that	;
;it's compatible with the huffman code.	;
;=======================================;

.org $d6a4
.mem 8
.index 8

var_0:					;#$E0

	bne var_1			;If not #$E0 branch to the next block of code.
	lda $0398			;Load the pointer number.

pt_load:
	jsr $d87c			;Load the pointer into RAM at $00-$01.

	ldy $0397			;The index for the name we're getting.
	lda ($00),y			;Get the current character.

	jsr $d7f0			;Load the tiles into RAM as you would for
					;the "normal" text.

	inc $0397			;Increment the index and see if the next character
	ldy $0397			;is a zero.
	lda ($00),y
	bne ram_prep			;If it isn't we need to prep RAM so that the variable control code
					;is read again.

	sta $0397			;If the next character is zero, however, we reset the pointer, and return
	jmp $fabb			;to the text read routine.


var_1:
	cmp #$e1
	bne var_2
					;This block is identical to var_0, except for the bytes of memory used.
	lda $039a			;Necessary for things where two variable names could appear at the same
					;time as in the Tournament mode and battle.
	jsr $d87c

	ldy $0399
	lda ($00),y

	jsr $d7f0

	inc $0399
	ldy $0399
	lda ($00),y
	bne ram_prep

	sta $0399
	jmp $fabb

var_2:
	cmp #$e2
	bne var_3

	ldy $039b			;Index.
	lda $039c,y			;Get the number from RAM. If it's #$FF, do nothing else here.
	bmi clear_2			;Reset index, and get ready for the next read.

	ora #$80			;If it's an actual number, however, we convert the value
	sta $0605,x			;to its tile number ($8X where X is the number), and store
	lda #$01			;it in RAM to be loaded into VRAM.
	sta $0604,x

	inc $039b			;Increment the index.
	cpy #$04			;A maximum of 5 numbers can be displayed per field (BP, etc).
	bcs clear_1			;If the index is greater than 5 (remember, 0 counts as 1 here)
					;reset the index.

	lda $039d,y
	bpl ram_prep

clear_1:
	lda #$00			;Reset the index.
	sta $039b
	jmp $fabb

clear_2:
	lda #$00			;Reset the index.
	sta $039b
	jmp $d6a0

var_3:
	cmp #$e3			;var_3 and var_4 are nearly identical to var_2.
	bne var_4
	ldy $03a1
	lda $03a2,y
	bmi clear_4

	ora #$80
	sta $0605,x
	lda #$01
	sta $0604,x

	inc $03a1
	cpy #$04
	bcs clear_3
	lda $03a3,y
	bmi clear_3

ram_prep:
	inc $51

huff_count:
	lda $06fc			;These three blocks of code are necessary in order for the huffman code
	sta $82				;to read the same character in again so that the variable code may be
					;executed properly.
huff_char:
	lda $06fd
	sta $83

huff_load:
	lda $06fb
	sta $50

	jmp $fabd			;Finally, jump back to the text read routine.

clear_3:
	lda #$00
	sta $03a1
	jmp $fabb

clear_4:
	lda #$00
	sta $03a1
	jmp $d6a0

var_4:
	cmp #$e4
	bne end

	ldy $03a7
	lda $03a8,y
	bmi clear_6

	ora #$80
	sta $0605,x
	lda #$01
	sta $0604,x

	inc $03a7
	cpy #$04
	bcs clear_5

	lda $03a9,y
	bmi clear_5
	bpl ram_prep

clear_5:
	lda #$00
	sta $03a7
	jmp $fabb

clear_6:
	lda #$00
	sta $03a7
	jmp $d6a0

end:
	tay				;If #$E5 or greater it's dictionary encoded.
	lda $d6fd,y			;Get the pointer number, and then load the pointer.
	jmp pt_load			;Then execute var_0 code.

.org $d7e2

dict:
	.db $00, $6c, $2b, $01		;Values for the innate dictionary encoding.
	.db $6d, $75, $12, $6e		;Multiply the value by two and add to $D8ED
	.db $06, $6f, $20, $02		;to determine where the pointer is in ROM.
	.db $03, $70